﻿package
{
	import flash.display.*;
	import flash.events.*;
	import flash.events.TimerEvent;
	import flash.utils.Timer;
	import flash.utils.getTimer;
	
	public class main extends MovieClip
	{
		public var playerChar:Object;
		public var waterObject:Object;
		public var killObject:Object;
		public var fixedObject:Array;
		public var enemyArray:Array;
		public var goalObject:Object;
		var flashTimer:Timer;
		var inTheWater:Timer;
		var secondsInWater:int = 0;
		var tickStarted:Boolean = false;
		var win:Boolean;
		
		public function startGame()
		{			
		
			fixedObject = new Array();
			enemyArray = new Array();
			checkLevel();
			addEventListener(Event.ENTER_FRAME, doThings);
			flashTimer = new Timer(200);
			flashTimer.addEventListener(TimerEvent.TIMER, growWater);
			flashTimer.start()
			inTheWater = new Timer(1000);
			inTheWater.addEventListener(TimerEvent.TIMER, waterTick);
			killObject = gameLevel.killplayer;
			goalObject = gameLevel.goal;

		}
		
		public function gameOver()
		{
			playerChar.removeEvents();
			playerChar.itemKey.removeEvents();
			for(var i:int=0;i<enemyArray.length;i++)
			{
				enemyArray[i].mc.removeEvents();
			}
			
			if(win)
			this.gotoAndStop('gameOver_win');
			else
			this.gotoAndStop('gameOver_lose');
		}
		
		public function waterTick(e:TimerEvent)
		{
			secondsInWater += 1;
			
			if(secondsInWater == 10)
			{
				win = false;
				gameOver();
			}
		}
		
		public function checkLevel()
		{
			for(var i:int=0;i<this.gameLevel.numChildren;i++)
			{
				var mc = this.gameLevel.getChildAt(i);
				if(mc is player)
				{
					playerChar = mc;
					playerChar.startGame();
				}
				if(mc is keyBox)
				{
					playerChar.itemKey = mc;
					playerChar.itemKey.startGame();
				}
				if(mc is Floor)
				{
					var floorObject:Object = new Object();
					floorObject.mc = mc;
					floorObject.leftSide = mc.x;
					floorObject.rightSide = mc.x + mc.width;
					floorObject.topSide = mc.y;
					floorObject.bottomSide = mc.y + mc.height;
					floorObject.fallHeight = mc.y - 9;
					floorObject.name = mc.name;
					fixedObject.push(floorObject);
				}
				if(mc is Water)
				{
					waterObject = mc;
				}
				if(mc is enemy)
				{
					var enemyObject:Object = new Object();
					enemyObject.mc = mc;
					enemyArray.push(enemyObject);
					
					enemyObject.mc.spawnMonster();
					enemyObject.mc.setPlayer(playerChar);
				}
			}
		}
		
		public function growWater(evt:TimerEvent)		
		{
			if(waterObject.y > 0)
			waterObject.y -= 1;
		}
		
		public function doThings(e:Event)
		{
			checkCollision();
			gravity(playerChar);
			//gravity(playerChar.itemKey);
			actions(playerChar);
			actions(playerChar.itemKey);
			
			if(playerChar.itemHeld)
			{
				updateKeyPos(playerChar.itemKey);
			}
			
		}
		
		
		public function checkCollision()
		{			
			if(playerChar.hitTestObject(playerChar.itemKey))
			{
				playerChar.touchingItem = true;
			}
			else
			{
				playerChar.touchingItem = false;
			}
			if(playerChar.y - playerChar.height > waterObject.y)
			{
				if(!tickStarted)
				{
					inTheWater.start();
					tickStarted = true;
				}
			}
			else
			{
				secondsInWater = 0;
				tickStarted = false;
			}
			
			if(playerChar.hitTestObject(killObject))
			{
				win = false;
				gameOver();
			}
			else if (playerChar.hitTestObject(goalObject) && playerChar.itemHeld)
			{
				win = true;
				gameOver();
			}
			
												   
		}
		
		public function gravity(gravityObject:Object)
		{
			if(gravityObject.applyGravity == true)
			{
				gravityObject.y += gravityObject.gravityApplied;
				if(gravityObject.gravityApplied == 0)
				{
					gravityObject.mainJumping = false;
				}
				if(gravityObject.gravityApplied <= gravityObject.gravityMax)
				{
					gravityObject.gravityApplied += gravityObject.gravityForce;
				}
				else
				{
					gravityObject.gravityApplied = gravityObject.gravityMax;
				}
			}
		}
		
		public function actions(actObject:Object)
		{
			if(playerChar.checkItem() == true)
			{
				for(var p:int=0;p<enemyArray.length;p++)
				{
					if(enemyArray[p].mc.tooClose)
					{
						win = false;
						gameOver();
						break;
					}
					
					enemyArray[p].mc.zKey = true;
				}
			}
			else
			{
				for(var m:int=0;m<enemyArray.length;m++)
				{
					enemyArray[m].mc.zKey = false;
				}
			}
			
			
			if(!actObject.mainJumping)
			{				
				for(var i:int=0;i<fixedObject.length;i++)
				{
					if(actObject != playerChar.itemKey)
					{
						if(actObject.y  > fixedObject[i].topSide && actObject.y  < fixedObject[i].bottomSide)
						{
							if((actObject.x + actObject.width/2) > fixedObject[i].leftSide && (actObject.x + actObject.width/2) < fixedObject[i].rightSide)
							{
								actObject.allowWalk = false;
								actObject.x = fixedObject[i].leftSide - actObject.width/2;
							}
							else if( actObject.leftKey && (actObject.x - actObject.width/2) > fixedObject[i].leftSide && (actObject.x - actObject.width/2) < fixedObject[i].rightSide)
							{
								actObject.allowWalk = false;
								actObject.x = fixedObject[i].rightSide + actObject.width/2;
							}
						}
					}
					if(actObject.y >= fixedObject[i].fallHeight && (actObject.y  -1) <= fixedObject[i].topSide)
					{
						if((actObject.x + actObject.mainSpeed) > fixedObject[i].leftSide && (actObject.x - actObject.mainSpeed) < fixedObject[i].rightSide )
						{
								actObject.applyGravity = false;
								actObject.gravityApplied = 0;
								actObject.y = fixedObject[i].topSide;
								actObject.allowJump = true;
								//actObject.inAir = false;
								//break;
						}
						else if(actObject != playerChar.itemKey)
						{
							actObject.applyGravity = true;
							//actObject.allowJump = false;
							actObject.inAir = true;
							
						}
					}
						
					
					
				}
			}
			
			
		}
		
		public function updateKeyPos(keyObject)
		{
			keyObject.x = playerChar.x;
			keyObject.y = playerChar.y;
		}
		
		function removeEvents()
		{
			removeEventListener(Event.ENTER_FRAME, doThings);
			flashTimer.stop();
			inTheWater.stop();
			flashTimer.removeEventListener(TimerEvent.TIMER, growWater);
			inTheWater.removeEventListener(TimerEvent.TIMER, waterTick);
		}
		
		
		
	}
	
}