﻿package
{
	import flash.display.*;
	import flash.events.*;
	
	public class player extends MovieClip
	{
		public var leftKey:Boolean;
		public var rightKey:Boolean;
		public var ctrlKey:Boolean;
		public var rightKeyCode:int = 39;
		public var leftKeyCode:int = 37;
		public var ctrlKeyCode:int = 17;
		public var upKeyCode:int = 38;
		public var itemHeld:Boolean = false;
		public var itemKey:Object;
		public var touchingItem:Boolean;
		public var gravityApplied:int = 0;
		public var gravityForce:int = 1;
		public var gravityMax:int = 9;
		public var applyGravity:Boolean;
		public var mainJumping:Boolean = false;
		public var mainSpeed:int = 3;
		public var allowJump:Boolean = false;
		public var inAir:Boolean = true;
		public var jumpHeight = -10;
		public var allowWalk:Boolean = true;
		public var playerState:String;
		public var oldState:String = null;
		
		
		public function startGame()
		{
			applyGravity = true;
			this.addEventListener(Event.ENTER_FRAME, guyLoop);
			stage.addEventListener(KeyboardEvent.KEY_DOWN, keyDownFunction);
			stage.addEventListener(KeyboardEvent.KEY_UP, keyUpFunction);
			playerState = 'idle';
			
		}
		
		public function guyLoop(e:Event)
		{
			moveObject(this);
			playerAnimation();
		}
		
		public function checkItem()
		{
			return itemHeld;
		}
		
		public function moveObject(moveObject:Object)
		{
			if(moveObject.allowWalk)
			{
				if(leftKey == true)
				{
					moveObject.scaleX = -.15;
					
					moveObject.x -= moveObject.mainSpeed;
				}
				else if(rightKey == true)
				{
					moveObject.scaleX = .15;
					
					moveObject.x += moveObject.mainSpeed;
				}
			}
		}
		
		public function keyDownFunction(e:KeyboardEvent)
		{
			//trace(e.keyCode);
			if(e.keyCode == leftKeyCode)
			{
				leftKey = true;
				if(itemHeld)
				itemKey.ax = -0.5;
				playerState = 'walking';

			}
			else if(e.keyCode == rightKeyCode)
			{
				rightKey = true;
				if(itemHeld)
				itemKey.ax = 0.5;
				playerState = 'walking';

			}
			if(e.keyCode == ctrlKeyCode && touchingItem)
			{
				if(itemHeld)
				{
					itemHeld = false;
					itemKey.letGo();
				}
				else
				{
					itemHeld = true;
					itemKey.holdItem();
				}
			}
			if(e.keyCode == upKeyCode)
			{
				mainJump();
				itemKey.ay = -0.5;
			}
		}
		
		public function keyUpFunction(e:KeyboardEvent)
		{
			if(e.keyCode == leftKeyCode)
			{
				leftKey = false;
				allowWalk = true;
			}
			else if(e.keyCode == rightKeyCode)
			{
				rightKey = false;
				allowWalk = true;
			}
			playerState = 'idle';

		}
		
		
		function mainJump()
		{	
			if(allowJump)
			{
				allowJump = false;
				mainJumping = true;
				gravityApplied = jumpHeight;
				applyGravity = true;
				inAir = true;
				playerState = 'jumping';
			
			}
			
		}
		
		function playerAnimation()
		{
			if(playerState == 'walking')
			{
				if(oldState != 'walking')
				{
					this.gotoAndPlay('walk');
					oldState = 'walking';
				}
			}
			else if(playerState == 'idle')
			{
				if(oldState != 'idle')
				{
					gotoAndStop('idle');
					oldState = 'idle';
				}
			}
			else if(playerState == 'jumping')
			{
				if(oldState != 'jump')
				{
					gotoAndPlay('jump');
					oldState = 'jump';
				}
			}
		}
		
		
		
		function removeEvents()
		{
			removeEventListener(Event.ENTER_FRAME, guyLoop);
			stage.removeEventListener(KeyboardEvent.KEY_DOWN, keyDownFunction);
			stage.removeEventListener(KeyboardEvent.KEY_UP, keyUpFunction);
		}
	}
	
	
}